-- W.R Hamming 
-- a. the list is in ascending order, without duplicates
-- b. the list begins with the number 1
-- c. if the list contains the number x, then it also contains the numbers 2x, 3x, and 5x
-- d. the lsit contains no other numbers (other than mentioned above)


-- The idea:
-- 1: (merge ( map 2 * hamming) ......)

merge xxs@(x:xs) yys@(y:ys) | x == y = x : merge xs ys
                            | x < y = x : merge xs yys      
                            | x > y = y : merge xxs ys

hamming = 1 : merge ( map (2*) hamming)
                    ( merge (map (3*) hamming)
                            (map (5*) hamming))



-- Monads
-- sugaryFriendLookup animalMap = do 
--  ponyFriend <- lookup "Pony" animalMap
--  ponyFriend1 <- lookup PonyFriend animalMap
--  ponyFriend2 <- lookup PonyFriend1 animalMap
--  return ponyFriend2 

-- given 2 lists [1,2] [3, 4, 5] and will return lists with result
-- [1,3] [1,4] [1,5] [2,3] [2,4] [2,5]

ret_tuple x_list y_list = [(x,y) | x <- x_list, y <- y_list]

-- convert to Monads
ret_tuple_monad x_list y_list = do 
                  x <- x_list
                  y <- y_list
                  return (x,y)


-- monad in another version
ret_tuple_monad_v2 x_list y_list = (x_list >>= \x -> y_list >>= \y -> return (x,y))

-- threading program state 
transformStmt expr counter = (newExpr, counter+1)
  where newExpr = "(define " ++ var ++ " " ++ expr ++ ")"
        var = "tmpVar" ++ (show counter)